<template>
  <section class="section">
    <h1 class="mb-4">
      Results
    </h1>

    <section class="content">
      <table class="table">
        <thead class="font-bold text-center">
          <tr>
            <td>Ballots</td>
            <td>Voters</td>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>
              <ViewRules
                v-if="contextRulesWithType.length > 0"
                :rules="contextRulesWithType"
              />

              <p v-else>
                All the ballots
              </p>
            </td>

            <td>
              <ViewRules
                v-if="groupRulesWithType.length > 0"
                :rules="groupRulesWithType"
              />

              <p v-else>
                Everybody
              </p>
            </td>
          </tr>
        </tbody>
      </table>

      <p class="my-4">
        {{ rows.length }} patterns found.
        <template v-if="filteredRows.length < rows.length">
          ({{ filteredRows.length }} shown)
        </template>
      </p>

      <table class="border-collapse w-full table">
        <thead>
          <tr class="bg-grey-lighter">
            <th
              v-for="column of columns"
              v-show="!column.hidden"
              :key="column.field"
              scope="col"
              class="border relative cursor-pointer p-2 px-6"
              @click="sortBy(column)"
            >
              <p class="flex-grow text-center">
                {{ column.label }}
              </p>

              <icon
                v-if="sortColumn === column"
                style="right: .5rem;"
                scale="1"
                class="absolute-center-vertical text-grey-dark"
                :name="invertSort ? 'arrow-down' : 'arrow-up'"
              />
            </th>
          </tr>

          <tr>
            <td
              v-for="column of columns"
              v-show="!column.hidden"
              :key="column.field"
            >
              <input
                v-show="displayFilterInput(column.field)"
                v-model="filters[column.field]"
              >
            </td>
          </tr>
        </thead>

        <tr
          v-for="row of sortedRows"
          :key="row.index"
          class="border transition alternate-background hover:bg-blue-lighter cursor-pointer"
          @click="showDetails({ row })"
        >
          <td class="border p-2">
            <div
              class="border border-grey-dark bg-red-lightest rounded-full border-light-gray overflow-hidden"
              style="min-width: 16rem; position: relative;"
            >
              <div
                class="h-full bg-red"
                :style="row.pattern.style_context_bar"
              />
              <div
                class="text-center text-white font-bold f6 h-4"
                role="progressbar"
                :style="row.pattern.style_progress"
              />
            </div>

            <p class="my-4">
              Usual agreement: {{ row.pattern.reliabilityRef }}<br>
              Context agreement: {{ row.pattern.reliabilityContext }}<br>
            </p>

            <p>
              P-value: {{ row.pattern.patternPValue }}
            </p>
          </td>

          <td class="border p-2">
            {{ row.stateIntraAgreement }}
          </td>

          <td class="border p-2">
            {{ row.group }}
          </td>

          <td class="border p-2">
            {{ row.context }}
          </td>
        </tr>
      </table>
    </section>

    <modal v-model="showModal">
      <DetailedResultsIntra
        class="p-4"
        :pattern="selected_result"
        :data-type="config.dataset.type"
      />
    </modal>
  </section>
</template>

<style lang="postcss" scoped>
.vgt-table thead th {
  vertical-align: middle;
}

.absolute-center-vertical {
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
}

.alternate-background:nth-child(odd):not(:hover) {
  @apply bg-grey-lighter;
}

.table {
  td {
    @apply border p-2;
  }
}
</style>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'
import { State } from 'vuex-class'

import 'vue-awesome/icons/arrow-up'
import 'vue-awesome/icons/arrow-down'
import Icon from 'vue-awesome/components/Icon.vue'

import DetailedResultsIntra from '@/components/DetailedResultsIntra.vue'
import Modal from '@/components/Modal.vue'
import ViewRules from '@/components/ViewRules.vue'

import _ from 'lodash/fp'

function colorPercentage ([r1, g1, b1], [r2, g2, b2], percentage) {
  const percent = (a, b) => a + (b - a) * percentage
  return [percent(r1, r2), percent(g1, g2), percent(b1, b2)]
}

function percentage (val) {
  return `${_.round(_.multiply(100, val))}%`
}

function displayRow ({
  index,
  group,
  context,
  sizeGroupSupport,
  sizeContextSupport,
  nbOutcomes,
  reliabilityDefault,
  reliabilityRef,
  reliabilityContextAllIndividuals,
  reliabilityContext,
  quality,
  confidenceInterval,
  patternPValue,
  stateIntraAgreement
}) {
  const style_context_bar = `width: 3px; position: absolute; left: ${percentage(reliabilityRef)};`
  const style_progress = `width: ${percentage(reliabilityContext)}; background: rgb(${colorPercentage([221, 75, 57], [0, 166, 90], reliabilityContext).join(',')});`

  return {
    index,
    pattern: {
      quality,
      confidenceInterval,
      nbOutcomes,
      reliabilityContext,
      reliabilityContextAllIndividuals,
      reliabilityDefault,
      reliabilityRef,
      sizeContextSupport,
      sizeGroupSupport,
      patternPValue,
      style_context_bar,
      style_progress
    },
    stateIntraAgreement,
    group,
    context
  }
}

const ruleTypes = [
  'inSet',
  'outSet',
  'inInterval',
  'outInterval',
  'lowerThan',
  'greaterThan',
  'contain_themes'
]

const getRuleType = _.compose([
  _.find((key) => (_.includes)(key)(ruleTypes)),
  _.keys])

const columns = [
  {
    label: 'Agreement-O-Meter',
    field: 'pattern',
    html: true,
    sortFn: _.get('pattern.quality')
  },
  {
    label: 'Intra-agreement',
    field: 'stateIntraAgreement'
  },
  {
    label: 'Group',
    field: 'group',
    sortFn: _.get('group'),
    filterOptions: {
      enabled: true
    }
  },
  {
    label: 'Context',
    field: 'context',
    html: true,
    sortFn: _.get('context'),
    filterOptions: {
      enabled: true
    }
  }
]

@Component({
  components: {
    DetailedResultsIntra,
    Icon,
    Modal,
    ViewRules
  }
})
export default class ResultsIntra extends Vue {
  get rows () {
    return _.map(displayRow, this.results)
  }

  get keysToFilterBy () {
    return _.map(_.get('field'))(_.filter(_.getOr(false, 'filterOptions.enabled'))(this.columns))
  }

  get filteredRows () {
    const checkRow = (row) => (key) => _.contains(_.toLower(_.getOr('', key, this.filters) as any as string), _.toLower(JSON.stringify(row[key])))

    return _.filter((row) => _.every(checkRow(row))(this.keysToFilterBy), this.rows)
  }

  get sortedRows () {
    const mapped = this.filteredRows.map((row, index) => ({ index, value: this.sortColumn.sortFn(row) }), this.rows)
    mapped.sort((a, b) => {
      if (a.value > b.value) {
        return 1
      } else if (a.value < b.value) {
        return -1
      } else {
        return 0
      }
    })

    if (this.invertSort) {
      mapped.reverse()
    }

    return _.map(({ index }) => this.filteredRows[index], mapped)
  }

  get contextRulesWithType () {
    return _.zip(this.config.contexts_scope, _.map(getRuleType, this.config.contexts_scope))
  }

  get groupRulesWithType () {
    return _.zip(this.config.individuals_scope, _.map(getRuleType, this.config.individuals_scope))
  }

  @Prop(Object) config
  @Prop(Array) results

  @State userID
  @State jobID

  columns = columns
  filters = {}
  selected_result = []
  showModal = false
  sortColumn = columns[0]
  invertSort = true

  sortBy (column) {
    if (this.sortColumn === column) {
      this.invertSort = !this.invertSort
    } else {
      this.invertSort = false
      this.sortColumn = column
    }
  }

  displayFilterInput (key) {
    return _.contains(key, this.keysToFilterBy)
  }

  showDetails ({
    row: {
      index
    }
  }) {
    this.selected_result = _.find(_.matchesProperty('index', index), this.results)
    this.showModal = true
  }
}
</script>
